#include <module.h>

import Stdio;

inherit "roxenlib";
inherit "module";

#define CRLF2 "\r\n\r\n"

/*
 * Simple Demo of a File-Upload module for Roxen/1.2alpha and up.
 *
 * (C) 1997 Thomas Abrahamsson <celeborn@lysator.liu.se>
 * This code can be used, modified and redistributed freely under the terms
 * of the GNU General Public License version 2.
 * This code comes on a AS-IS basis, with NO WARRANTY OF ANY KIND, either
 * implicit or explicit. Use at your own risk.
 *
 */


array register_module()
{
  return ({
    MODULE_LOCATION,
      "Uploadtest",
      "Uploadtesttyp",
      0,
      0,
      });
}

void create()
{
  defvar("uploadpath", "/tmp/", "Upload destination in filesystem", TYPE_DIR, "");
  defvar("mountpoint", "/upload/", "Mountpoint", TYPE_LOCATION, "");
}

string query_location()
{
  return query("mountpoint");
}

mapping find_file(string file_name, object req_id)
{
  string original_file_name, store_as_file_name, data;
  string original_file_name=(req_id->variables["upload-file.filename"])||"";
  string store_as_file_name=(req_id->variables["save-as-filename"])||"";
  string data=(req_id->variables["upload-file"])||"";

  if (store_as_file_name=="") store_as_file_name=original_file_name;
  if ((data!="") && (original_file_name!=""))
  {
    string full_file_name=query("uploadpath")+store_as_file_name;
    rm(full_file_name);
    int start=search(data, CRLF2);
    if (start==-1)
      start=0;
    else
      start+=4;
    object filen=File();
    filen->open(full_file_name, "wtc");
    filen->write(data[start..99999999]);
    filen->close();
    return http_string_answer("File uploaded successfully. Got "+(strlen(data)-start)+" bytes. Stored as "+full_file_name+".");
  } 
  return http_string_answer("File uploaded failed.");
}



